#!/bin/sh

var=$1
node=("NodeA" "NodeB" "NodeC" "NodeD" "NodeE" "NodeF" "NodeG" "NodeH")
iplist1=("10.2.2.101" "10.2.2.103" "10.2.2.105" "10.2.2.107" "10.2.2.109" "10.2.2.111" "10.2.2.113" "10.2.2.115" )
iplist2=("10.2.2.102" "10.2.2.104" "10.2.2.106" "10.2.2.108" "10.2.2.110" "10.2.2.112" "10.2.2.114" "10.2.2.116" )

# configuration
echo "---- Start Timestamp: `date` ----" > profile_$1_ms5580g2.txt
echo "<<< Configuration Information >>>" >> profile_$1_ms5580g2.txt
echo "" >> profile_$1_ms5580g2.txt
echo "1.System Parameter" >> profile_$1_ms5580g2.txt
echo "2.Controller Info" >> profile_$1_ms5580g2.txt
echo "3.Frontend/Backend Connection" >> profile_$1_ms5580g2.txt
echo "4.DSU List/Disk List" >> profile_$1_ms5580g2.txt
echo "5.DSU Details" >> profile_$1_ms5580g2.txt
echo "6.Disk Details" >> profile_$1_ms5580g2.txt
echo "7.RAID Details" >> profile_$1_ms5580g2.txt
echo "8.LUN List" >> profile_$1_ms5580g2.txt
echo "9.LUN Details" >> profile_$1_ms5580g2.txt
echo "10.FC Module" >> profile_$1_ms5580g2.txt
echo "11.Email Notification" >> profile_$1_ms5580g2.txt
echo "12.SNMP Notification" >> profile_$1_ms5580g2.txt
echo "13.HotCache" >> profile_$1_ms5580g2.txt
echo "14.Private Network" >> profile_$1_ms5580g2.txt

# 1.system parameter
echo "" >> profile_$1_ms5580g2.txt
echo "*********************************************" >> profile_$1_ms5580g2.txt
echo "********* 1.System Parameter *********" >> profile_$1_ms5580g2.txt
echo "*********************************************" >> profile_$1_ms5580g2.txt
echo "" >> profile_$1_ms5580g2.txt

ms-cli ALL "HWManager -g -all" >> profile_$1_ms5580g2.txt

# 2.controller firmware
echo "" >> profile_$1_ms5580g2.txt
echo "*********************************************" >> profile_$1_ms5580g2.txt
echo "********* 2.Controller Info *********" >> profile_$1_ms5580g2.txt
echo "*********************************************" >> profile_$1_ms5580g2.txt
echo "" >> profile_$1_ms5580g2.txt

echo "== Controller Version =======================" >> profile_$1_ms5580g2.txt
ms-cli ALL "system mgt getversion" >> profile_$1_ms5580g2.txt

echo "== Cache Info ===============================" >> profile_$1_ms5580g2.txt

# [modify]
for ((h=0;h<8;h++))
do
	echo "${node[$h]} SP1 Cache:" >> profile_$1_ms5580g2.txt
	ssh root@${iplist1[$h]} "sh /home/driver/chk_mem/localmeminfo |sed 's/^/   Cache Size:/' |sed 's/$/GB/'" >> profile_$1_ms5580g2.txt
	echo "${node[$h]} SP2 Cache:" >> profile_$1_ms5580g2.txt
	ssh root@${iplist2[$h]} "sh /home/driver/chk_mem/localmeminfo |sed 's/^/   Cache Size:/' |sed 's/$/GB/'" >> profile_$1_ms5580g2.txt
done
echo "" >> profile_$1_ms5580g2.txt

# 3.Frontend/Backend Connection
echo "" >> profile_$1_ms5580g2.txt
echo "*********************************************" >> profile_$1_ms5580g2.txt
echo "********* 3.Frontend/Backend Connection *****" >> profile_$1_ms5580g2.txt
echo "*********************************************" >> profile_$1_ms5580g2.txt
echo "" >> profile_$1_ms5580g2.txt

echo "== Frontend Connection ======================" >> profile_$1_ms5580g2.txt
echo "" >> profile_$1_ms5580g2.txt

ms-cli ALL "client target queryhbalist" |sed "s/velocity  : 16/velocity  : 16 Gbps/g" -  >> profile_$1_ms5580g2.txt
# [modify]
echo "== Backend Connection ======================" >> profile_$1_ms5580g2.txt
echo "" >> profile_$1_ms5580g2.txt
for ((i=0;i<8;i++))
do
    echo "${node[$i]} SP1:" >> profile_$1_ms5580g2.txt
    ms-cli ${node[$i]} "system sas getportlist -c 1:6" >> profile_$1_ms5580g2.txt
    echo "" >> profile_$1_ms5580g2.txt

    ms-cli ${node[$i]} "system sas getportlist -c 1:9" >> profile_$1_ms5580g2.txt
    echo "" >> profile_$1_ms5580g2.txt

    ms-cli ${node[$i]} "system sas getportlist -c 1:10" >> profile_$1_ms5580g2.txt
    echo "" >> profile_$1_ms5580g2.txt

    echo "${node[$i]} SP2:" >> profile_$1_ms5580g2.txt
    ms-cli ${node[$i]} "system sas getportlist -c 2:6" >> profile_$1_ms5580g2.txt
    echo "" >> profile_$1_ms5580g2.txt

    ms-cli ${node[$i]} "system sas getportlist -c 2:9" >> profile_$1_ms5580g2.txt
    echo "" >> profile_$1_ms5580g2.txt

    ms-cli ${node[$i]} "system sas getportlist -c 2:10" >> profile_$1_ms5580g2.txt
    echo "" >> profile_$1_ms5580g2.txt

    echo "======================" >> profile_$1_ms5580g2.txt
done

# 4.dsu/disk List
echo "" >> profile_$1_ms5580g2.txt
echo "*********************************************" >> profile_$1_ms5580g2.txt
echo "********* 4.DSU/Disk List *********" >> profile_$1_ms5580g2.txt
echo "*********************************************" >> profile_$1_ms5580g2.txt
echo "" >> profile_$1_ms5580g2.txt

echo "== DSU List =================================" >> profile_$1_ms5580g2.txt
ms-cli ALL "dsu mgt getlist" >> profile_$1_ms5580g2.txt

echo "== Disk List ================================" >> profile_$1_ms5580g2.txt
echo "" >> profile_$1_ms5580g2.txt
# [modify]
for ((j=0;j<8;j++))
do
	echo  "${node[$j]}:" >> profile_$1_ms5580g2.txt
	for dsu in `ms-cli ${node[$j]} "dsu mgt getlist"| grep Name | awk 'BEGIN {FS=" "}{print$2}'`
	do
		echo "--$dsu ---------------------------------" >> profile_$1_ms5580g2.txt
		
		ms-cli ${node[$j]} "disk mgt getlist -d $dsu"  >> profile_$1_ms5580g2.txt
	done
done

#5.DSU Details
echo "" >> profile_$1_ms5580g2.txt
echo "*********************************************" >> profile_$1_ms5580g2.txt
echo "********* 5.DSU Details *********" >> profile_$1_ms5580g2.txt
echo "*********************************************" >> profile_$1_ms5580g2.txt

echo "" >> profile_$1_ms5580g2.txt
# [modify]
for ((q=0;q<8;q++))
do
	echo  "${node[$q]}:" >> profile_$1_ms5580g2.txt
	echo "--DSU battery ---------------------------------" >> profile_$1_ms5580g2.txt
	ms-cli ${node[$q]} "dsu battery query -d 10:1:1"  >> profile_$1_ms5580g2.txt
	for dsu in `ms-cli ${node[$q]} "dsu mgt getlist"| grep Name | awk 'BEGIN {FS=" "}{print$2}'`
	do
		echo "--$dsu ---------------------------------" >> profile_$1_ms5580g2.txt
		ms-cli ${node[$q]} "dsu mgt query -d $dsu"  >> profile_$1_ms5580g2.txt
	done
done

# 6.disk details
echo "" >> profile_$1_ms5580g2.txt
echo "*********************************************" >> profile_$1_ms5580g2.txt
echo "********* 6.Disk Details *********" >> profile_$1_ms5580g2.txt
echo "*********************************************" >> profile_$1_ms5580g2.txt
echo "" >> profile_$1_ms5580g2.txt
# [modify]
for ((k=0;k<8;k++))
do
	echo "${node[$k]}:" >> profile_$1_ms5580g2.txt
	for dsu in `ms-cli ${node[$k]} "dsu mgt getlist"| grep Name | awk 'BEGIN {FS=" "}{print$2}'`
	do
        echo "==$dsu =================================" >> profile_$1_ms5580g2.txt
        for disk in `ms-cli ${node[$k]} "disk mgt getlist -d $dsu" | grep Name |cut -d : -f 5|sort -n`
        do
			ms-cli ${node[$k]} "disk mgt query -d $dsu:$disk" >> profile_$1_ms5580g2.txt
        done
	done
	echo "" >> profile_$1_ms5580g2.txt
done

# 7.raid details
echo "" >> profile_$1_ms5580g2.txt
echo "*********************************************" >> profile_$1_ms5580g2.txt
echo "********* 7.RAID Details *********" >> profile_$1_ms5580g2.txt
echo "*********************************************" >> profile_$1_ms5580g2.txt
echo "" >> profile_$1_ms5580g2.txt

# [modify]
for ((l=0;l<8;l++))
do
	echo "${node[$l]}:" >> profile_$1_ms5580g2.txt
	for pool in `ms-cli ${node[$l]} "pool mgt getlist"| grep Name |awk 'BEGIN {FS=" "}{print$2}'`
	do 
		echo "== $pool ===================================" >> profile_$1_ms5580g2.txt
		for raid in `ms-cli ${node[$l]} "raid mgt getlist -p $pool"| grep Name|awk 'BEGIN {FS=" "}{print$2}'`
		do
			echo "-- $raid ----------------------------------" >> profile_$1_ms5580g2.txt
			ms-cli ${node[$l]} "raid mgt query -n $raid" >> profile_$1_ms5580g2.txt
			echo "" >> profile_$1_ms5580g2.txt
			done
	done
	echo "" >> profile_$1_ms5580g2.txt
done

# 8.lun list
echo "" >> profile_$1_ms5580g2.txt
echo "*********************************************" >> profile_$1_ms5580g2.txt
echo "*********	8.LUN List *********" >> profile_$1_ms5580g2.txt
echo "*********************************************" >> profile_$1_ms5580g2.txt
echo "" >> profile_$1_ms5580g2.txt
for ((n=0;n<8;n++))
do
	echo "${node[$n]}:" >> profile_$1_ms5580g2.txt
	for pool in `ms-cli ${node[$n]} "pool mgt getlist"| grep Name |awk 'BEGIN {FS=" "}{print$2}'`
	do 
		echo "== $pool ===================================" >> profile_$1_ms5580g2.txt
		ms-cli ${node[$n]} "lun mgt getlist -p $pool" >> profile_$1_ms5580g2.txt
	done
done	
echo "" >> profile_$1_ms5580g2.txt

# 9.lun details
echo "" >> profile_$1_ms5580g2.txt
echo "*********************************************" >> profile_$1_ms5580g2.txt
echo "********* 9.LUN Details *********" >> profile_$1_ms5580g2.txt
echo "*********************************************" >> profile_$1_ms5580g2.txt
echo "" >> profile_$1_ms5580g2.txt
for ((m=0;m<8;m++))
do
	echo "${node[$m]}:" >> profile_$1_ms5580g2.txt
	for pool in `ms-cli ${node[$m]} "pool mgt getlist"| grep Name |awk 'BEGIN {FS=" "}{print$2}'`
	do 
		echo "== $pool ===================================" >> profile_$1_ms5580g2.txt
		for lun in `ms-cli ${node[$m]} "lun mgt getlist -p $pool"| grep Name|awk 'BEGIN {FS=" "}{print$2}'`
		do
			echo "-- $lun ----------------------------------" >> profile_$1_ms5580g2.txt
			ms-cli ${node[$m]} "lun mgt query -n $lun" >> profile_$1_ms5580g2.txt
			echo "" >> profile_$1_ms5580g2.txt
			done
	done
	echo "" >> profile_$1_ms5580g2.txt
done

# 10.fc module
echo "" >> profile_$1_ms5580g2.txt
echo "*********************************************" >> profile_$1_ms5580g2.txt
echo "********* 10.FC Module *********" >> profile_$1_ms5580g2.txt
echo "*********************************************" >> profile_$1_ms5580g2.txt
echo "" >> profile_$1_ms5580g2.txt

ms-cli ALL "client target queryportlist"  >> profile_$1_ms5580g2.txt

# 11.email notification
echo "" >> profile_$1_ms5580g2.txt
echo "*********************************************" >> profile_$1_ms5580g2.txt
echo "********* 11.Email Notification *********" >> profile_$1_ms5580g2.txt
echo "*********************************************" >> profile_$1_ms5580g2.txt
echo "" >> profile_$1_ms5580g2.txt

ms-cli ALL "alarm email query" >> profile_$1_ms5580g2.txt

# 12.snmp notification
echo "" >> profile_$1_ms5580g2.txt
echo "*********************************************" >> profile_$1_ms5580g2.txt
echo "********* 12.SNMP Notification *********" >> profile_$1_ms5580g2.txt
echo "*********************************************" >> profile_$1_ms5580g2.txt
echo "" >> profile_$1_ms5580g2.txt

ms-cli ALL "alarm snmp query" >> profile_$1_ms5580g2.txt

# 13.hotcache
echo "" >> profile_$1_ms5580g2.txt
echo "*********************************************" >> profile_$1_ms5580g2.txt
echo "********* 13.HotCache *********" >> profile_$1_ms5580g2.txt
echo "*********************************************" >> profile_$1_ms5580g2.txt
echo "" >> profile_$1_ms5580g2.txt

ms-cli ALL "hotcache mgt query" >> profile_$1_ms5580g2.txt

#14.Private Network information
echo "" >> profile_$1_ms5580g2.txt
echo "*********************************************" >> profile_$1_ms5580g2.txt
echo "********* 14.Private Network *********" >> profile_$1_ms5580g2.txt
echo "*********************************************" >> profile_$1_ms5580g2.txt
echo "" >> profile_$1_ms5580g2.txt  
for ((p=0;p<8;p++))
do
	echo "" >> profile_$1_ms5580g2.txt  
	echo "---- ${node[$p]} SP1 Private Network ----"   >> profile_$1_ms5580g2.txt
	ssh root@${iplist1[$p]} ifconfig eth_1_5_1 |grep broadcast|awk -F ' ' '{print $1,$2}'|awk -F ' ' '{print "'${node[$p]}'_SP1 eth_1_5_1 addr:",$2}' >> profile_$1_ms5580g2.txt  
	ssh root@${iplist1[$p]} ethtool eth_1_5_1 |grep -i speed |awk -F ':' '{print "'${node[$p]}'_SP1 eth_1_5_1 speed:",$2}'>> profile_$1_ms5580g2.txt  
	ssh root@${iplist1[$p]} ifconfig eth_1_5_2 |grep broadcast|awk -F ' ' '{print $1,$2}'|awk -F ' ' '{print "'${node[$p]}'_SP1 eth_1_5_2 addr:",$2}' >> profile_$1_ms5580g2.txt     
	ssh root@${iplist1[$p]} ethtool eth_1_5_2 |grep -i speed |awk -F ':' '{print "'${node[$p]}'_SP1 eth_1_5_2 speed:",$2}'>> profile_$1_ms5580g2.txt  
	echo "" >> profile_$1_ms5580g2.txt  

	echo "" >> profile_$1_ms5580g2.txt  
	echo "---- ${node[$p]} SP2 Private Network ----"   >> profile_$1_ms5580g2.txt
	ssh root@${iplist2[$p]} ifconfig eth_2_5_1 |grep broadcast|awk -F ' ' '{print $1,$2}'|awk -F ' ' '{print "'${node[$p]}'_SP2 eth_2_5_1 addr:",$2}' >> profile_$1_ms5580g2.txt  
	ssh root@${iplist2[$p]} ethtool eth_2_5_1 |grep -i speed |awk -F ':' '{print "'${node[$p]}'_SP2 eth_2_5_1 speed:",$2}'>> profile_$1_ms5580g2.txt  
	ssh root@${iplist2[$p]} ifconfig eth_2_5_2 |grep broadcast|awk -F ' ' '{print $1,$2}'|awk -F ' ' '{print "'${node[$p]}'_SP2 eth_2_5_2 addr:",$2}' >> profile_$1_ms5580g2.txt     
	ssh root@${iplist2[$p]} ethtool eth_2_5_2 |grep -i speed |awk -F ':' '{print "'${node[$p]}'_SP2 eth_2_5_2 speed:",$2}'>> profile_$1_ms5580g2.txt  
	echo "" >> profile_$1_ms5580g2.txt 
done
echo "---- End Timestamp: `date` ----" >> profile_$1_ms5580g2.txt

